package net.sourceforge.ganttproject.gui;

/**
 *
 * <p>Title: </p>
 *
 * <p>Description: Provide the properties of selected task</p>
 *
 * <p>Copyright: Copyright (c) 2003</p>
 *
 * <p>Company: </p>
 *
 * @author ganttproject
 *
 * @version 1.0
 *
 */

import java.util.Hashtable;
import java.util.ArrayList;
import java.util.Vector;

import java.awt.Color;
import java.awt.BorderLayout;
import java.awt.GridBagLayout;
import java.awt.FlowLayout;
import java.awt.GridBagConstraints;
import java.awt.Container;
import java.awt.Component;
import java.awt.Dimension;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

import javax.swing.JScrollPane;
import javax.swing.JComboBox;
import javax.swing.JCheckBox;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JTextArea;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.JColorChooser;
import javax.swing.JDialog;
import javax.swing.JSpinner;
import javax.swing.JLabel;
import javax.swing.JPanel; 
import javax.swing.DefaultCellEditor;
import javax.swing.JTabbedPane;
import javax.swing.SpinnerNumberModel;

import javax.swing.border.EtchedBorder;
import javax.swing.border.TitledBorder;
import javax.swing.event.ChangeListener;
import javax.swing.event.ChangeEvent;
import javax.swing.table.TableColumn;
import javax.swing.table.AbstractTableModel;
import javax.swing.table.TableModel;
import javax.swing.tree.DefaultMutableTreeNode;
import java.lang.Class;
import net.sourceforge.ganttproject.language.GanttLanguage;
import net.sourceforge.ganttproject.resource.HumanResource;
import net.sourceforge.ganttproject.resource.HumanResourceManager;
import net.sourceforge.ganttproject.task.TaskManager;
import java.util.Iterator;
import net.sourceforge.ganttproject.shape.ShapeConstants;
import net.sourceforge.ganttproject.shape.ShapePaint;
import net.sourceforge.ganttproject.shape.JPaintCombo;
import net.sourceforge.ganttproject.GanttTask;
import net.sourceforge.ganttproject.TestGanttRolloverButton;
import net.sourceforge.ganttproject.GanttCalendar;
import net.sourceforge.ganttproject.GanttTaskRelationship;
import net.sourceforge.ganttproject.GanttTree;
import net.sourceforge.ganttproject.GanttGraphicArea;
import net.sourceforge.ganttproject.GanttProject;


/**
  *Real panel for editing task properties
  */
public class GanttTaskPropertiesBean

    extends JPanel {

  //Input attributes

  protected GanttTask selectedTask; //Task whose properties will be shown
  
  protected Vector savePredecessors;

  private GanttTree tree; //GanttTree that contain all the tasks information

  private GanttLanguage language = GanttLanguage.getInstance(); // language the panel will display

  private JDialog parent;

  //Output attributes: you can find the definition is GanttTask

  private String name;

  private int length;

  private int percentComplete;

  private int priority;

  private GanttCalendar start;

  private GanttCalendar end;

  private boolean bilan;

  private Vector predecessors;

  private String notes;

  private Hashtable managerHash;

  private Hashtable assignedResources = new Hashtable();
  //private attributes for internal use

  GridBagConstraints gbc = new GridBagConstraints();

  FlowLayout flowL = new FlowLayout(FlowLayout.LEFT, 10, 10);

  JTabbedPane tabbedPane; //TabbedPane that include the following four items

  JPanel generalPanel;

  JPanel predecessorsPanel;

  JPanel resourcesPanel;

  JPanel notesPanel;

  //Components on general pannel

  JPanel firstRowPanel1; //components in first row

  JTextField nameField1;

  JTextField durationField1;

  JLabel nameLabel1;

  JLabel durationLabel1;

  JPanel secondRowPanel1; //components in second row

  JSpinner percentCompleteSlider;

  JLabel percentCompleteLabel1;

  JLabel priorityLabel1;

  JComboBox priorityComboBox;

  JPanel thirdRowPanel1; //componets in third row

  JTextField startDateField1;

  JTextField finishDateField1;

  JLabel startDateLabel1;

  JLabel finishDateLabel1;

  JButton startDateButton1;

  JButton finishDateButton1;

  JPanel lastRowPanel1; //components in last row

  JLabel mileStoneLabel1;

  JCheckBox mileStoneCheckBox1;

  JButton colorButton;

  JButton colorSpace;

  JPanel colorPanel;
  
  /** Shape chooser combo Box */
  JPaintCombo shapeComboBox;

  //Components on predecessors pannel

  JLabel nameLabel2; //first row, here the textfield is un-editable

  JLabel durationLabel2;

  JTextField nameField2;

  JTextField durationField2;

  JPanel firstRowPanel2;

  JScrollPane predecessorsScrollPane; //second row, a table

  JTable predecessorsTable;

  //Components on resourses pannel

  JLabel nameLabel3;

  JLabel durationLabel3;

  JTextField nameField3;

  JTextField durationField3;

  JPanel firstRowPanel3;

  JScrollPane resourcesScrollPane;

  JTable resourcesTable;

  //Components on notes pannel

  JLabel nameLabelNotes;

  JLabel durationLabelNotes;

  JTextField nameFieldNotes;

  JTextField durationFieldNotes;

  JScrollPane scrollPaneNotes;

  JTextArea noteAreaNotes;

  JPanel firstRowPanelNotes;

  JPanel secondRowPanelNotes;

  //Component on the SOUTH ok CANCEL buttons

  JButton okButton;

  JButton cancelButton;

  JPanel southPanel;

  /**add a component to container by using GridBagConstraints.*/

  private void addUsingGBL(Container container, Component component,

                           GridBagConstraints gbc, int x,

                           int y, int w, int h) {
    gbc.gridx = x;
    gbc.gridy = y;
    gbc.gridwidth = w;
    gbc.gridheight = h;
    gbc.weighty = 0;
    container.add(component, gbc);
  }

  /**set the first row in all the tabbed pane. thus give them a common look*/

  private void setFirstRow(Container container, GridBagConstraints gbc,
                           JLabel nameLabel, JTextField nameField,
                           JLabel durationLabel, JTextField durationField) {
    container.setLayout(new GridBagLayout());
    gbc.weightx = 0;
    gbc.weighty = 0;
    gbc.anchor = GridBagConstraints.WEST;
    gbc.insets.right = 15;
    gbc.insets.left = 10;
    gbc.insets.top = 10;
    addUsingGBL(container, nameLabel, gbc, 0, 0, 1, 1);
    addUsingGBL(container, nameField, gbc, 1, 0, 1, 1);
    addUsingGBL(container, durationLabel, gbc, 2, 0, 1, 1);
    gbc.weightx = 1;
    addUsingGBL(container, durationField, gbc, 3, 0, 1, 1);
  }

  /**set the relationship editor for predecessors' table*/
  private void setUpTypeComboColumn(TableColumn typeColumn) {
    //Set up the editor for the sport cells.
    JComboBox comboBox = new JComboBox();
    comboBox.addItem(language.getText("finishstart"));
    comboBox.addItem(language.getText("finishfinish"));
    comboBox.addItem(language.getText("startfinish"));
    comboBox.addItem(language.getText("startstart"));
    comboBox.setSelectedIndex(0);
    comboBox.setEditable(false);
    typeColumn.setCellEditor(new DefaultCellEditor(comboBox));
  }

  /**set predecessor editor for predecessors' table*/
  private void setUpPredecessorComboColumn(TableColumn predecessorColumn, final JTable predecessorTable) {
    //Set up the editor for the sport cells.
    final JComboBox comboBox = new JComboBox();
    if (tree != null) {
      ArrayList allTasks = tree.getAllTasks();
      //comboBox.addItem("no set");
      //for (int i = 0; i < allTasks.size(); i++) {
        //DefaultMutableTreeNode treeNode = (DefaultMutableTreeNode) allTasks.get(i);
      for (Iterator it = allTasks.iterator(); it.hasNext();) {
	DefaultMutableTreeNode treeNode = (DefaultMutableTreeNode)it.next();
	
	
	if(((GanttTask)(treeNode.getUserObject())).getTaskID() != selectedTask.getTaskID()) {
          if (!treeNode.isRoot()) { //not root node
            if (treeNode.getChildCount() == 0) { //not mother node
              GanttTask nodeTask = (GanttTask) treeNode.getUserObject();
              comboBox.addItem(""+nodeTask.getTaskID()+" - "+nodeTask.toString());
            }
          }
	}
      }
      
      comboBox.addActionListener(new ActionListener() {
	      public void actionPerformed(ActionEvent e) {
		    if(predecessorTable.getEditingRow()!=-1){
		 	String taskName = (String) comboBox.getSelectedItem();
			 if(taskName.length()!=0) {
			 	int indexOfTiret = taskName.indexOf(" - ");
				if(indexOfTiret>=0) {
					 String stringTtaskID = taskName.substring(0,indexOfTiret);
					 int taskID = new Integer(stringTtaskID).intValue();
					 if(selectedTask.getTaskID()==taskID) {
					 	predecessorTable.setValueAt("",predecessorTable.getEditingRow(),0);
					 	predecessorTable.setValueAt("",predecessorTable.getEditingRow(),1);
					 	predecessorTable.setValueAt("",predecessorTable.getEditingRow(),2);
					 } else {
						 predecessorTable.setValueAt(stringTtaskID,predecessorTable.getEditingRow(),0);
						 predecessorTable.setValueAt(language.getText("finishstart"),predecessorTable.getEditingRow(),2);
					}
				}
			 }
		   } //else System.out.println("You're edit no line.....this message has not to appear");
	      }
      });
      
    }
    else { //for debug purpose
      comboBox.addItem("Task1");
      comboBox.addItem("Task2");
      comboBox.addItem("Task3");
      comboBox.addItem("Task4");
      comboBox.addItem("Task5");
    }
    comboBox.setEditable(true);
    predecessorColumn.setCellEditor(new DefaultCellEditor(comboBox));
  }

  /**set resources editor for resources table*/
  private void setUpResourcesComboColumn(ArrayList users,
                                         final JTable resourceTable) {
    final JComboBox comboBox = new JComboBox();
    for (int i = 0; i < users.size(); i++) {
      comboBox.addItem(users.get(i));
    }

    TableColumn resourcesColumn = resourceTable.getColumnModel().getColumn(1);
    comboBox.setEditable(false);
    resourcesColumn.setCellEditor(new DefaultCellEditor(comboBox));
    comboBox.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        HumanResource hr = (HumanResource) comboBox.getSelectedItem();
        if (hr != null && resourceTable.getEditingRow() != -1) {
          // if the resource is already selected we
          // cannot assign it again

          resourceTable.setValueAt(String.valueOf(hr.getId()), resourceTable.getEditingRow(), 0);
	  if(!(resourceTable.getValueAt(resourceTable.getEditingRow(),2) instanceof String))
		resourceTable.setValueAt("100", resourceTable.getEditingRow(), 2);
        }
      }
    });
  }

  /**Construct the general panel*/
  private void constructGeneralPanel() {
    generalPanel = new JPanel(new GridBagLayout());
    //first row
    nameLabel1 = new JLabel(language.getText("name") + ":");
    nameField1 = new JTextField(20);
    nameField1.setName("name_of_task");
    durationLabel1 = new JLabel(language.getText("length") + ":");
    durationField1 = new JTextField(8);
    durationField1.setName("length");
    firstRowPanel1 = new JPanel(flowL);
    setFirstRow(firstRowPanel1, gbc, nameLabel1, nameField1, durationLabel1,
                durationField1);
    //second row
    percentCompleteLabel1 = new JLabel(language.getText("advancement")); //Progress
    SpinnerNumberModel spinnerModel = new SpinnerNumberModel(0, 0, 100, 1);
    percentCompleteSlider = new JSpinner(spinnerModel);


    secondRowPanel1 = new JPanel(flowL);
    secondRowPanel1.add(percentCompleteLabel1);
    //secondRowPanel1.add(percentCompleteField1);
    secondRowPanel1.add(percentCompleteSlider);
    priorityLabel1 = new JLabel(language.getText("priority"));
    secondRowPanel1.add(priorityLabel1);
    priorityComboBox = new JComboBox();
    priorityComboBox.addItem(language.getText("low"));
    priorityComboBox.addItem(language.getText("normal"));
    priorityComboBox.addItem(language.getText("hight"));
    priorityComboBox.setEditable(false);

    secondRowPanel1.add(priorityComboBox);

    //third row

    startDateLabel1 = new JLabel(language.getText("dateOfBegining") + ":");
    startDateField1 = new JTextField(12);
    startDateField1.setEditable(false);
    finishDateLabel1 = new JLabel(language.getText("dateOfEnd") + ":");

    finishDateField1 = new JTextField(12);
    finishDateField1.setEditable(false);

    ImageIcon icon = new ImageIcon(getClass().getResource("/icons/calendar_16.gif"));

    startDateButton1 = new TestGanttRolloverButton(icon);
    startDateButton1.setName("start");
		startDateButton1.setToolTipText("<html><body bgcolor=#FFFFBD>" + language.getText("chooseDate") +
                         "</body></html>");
    finishDateButton1 = new TestGanttRolloverButton(icon);
    finishDateButton1.setName("finish");
		finishDateButton1.setToolTipText("<html><body bgcolor=#FFFFBD>" + language.getText("chooseDate") +
                         "</body></html>");
    thirdRowPanel1 = new JPanel(flowL);
    thirdRowPanel1.setBorder(new TitledBorder(new EtchedBorder(), language.getText("date")));
    thirdRowPanel1.add(startDateLabel1);
    thirdRowPanel1.add(startDateField1);
    thirdRowPanel1.add(startDateButton1);
    thirdRowPanel1.add(finishDateLabel1);
    thirdRowPanel1.add(finishDateField1);
    thirdRowPanel1.add(finishDateButton1);

    //last row

    mileStoneCheckBox1 = new JCheckBox(language.getText("meetingPoint")); //Milestone
    lastRowPanel1 = new JPanel(flowL);
    lastRowPanel1.add(mileStoneCheckBox1);
    
    shapeComboBox = new JPaintCombo(ShapeConstants.PATTERN_LIST);


    JPanel shapePanel = new JPanel();
    shapePanel.setLayout(new BorderLayout());
    JLabel lshape = new JLabel("  "+language.getText("shape")+" ");
    shapeComboBox = new JPaintCombo(ShapeConstants.PATTERN_LIST);

    shapePanel.add(lshape, BorderLayout.WEST);
    shapePanel.add(shapeComboBox, BorderLayout.CENTER);
    
    
    colorButton = new JButton(language.getText("colorButton"));
    colorButton.setBackground(selectedTask.getColor());
    final String colorChooserTitle = language.getText("selectColor");
    colorButton.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        JDialog dialog;
        dialog = JColorChooser.createDialog(parent, colorChooserTitle, true,
                                            GanttDialogProperties.colorChooser,
                                            new ActionListener() {
          public void actionPerformed(ActionEvent e) {
            colorButton.setBackground(GanttDialogProperties.colorChooser.
                                      getColor());
          }
        }

        , new ActionListener() {
          public void actionPerformed(ActionEvent e) {
            // nothing to do for "Cancel"
          }
        });

        dialog.show();
      }
    });

    colorSpace = new JButton(language.getText("defaultColor"));
    colorSpace.setBackground(GanttGraphicArea.taskDefaultColor);
    colorSpace.setToolTipText("<html><body bgcolor=#FFFFBD>" +
                              language.getText("resetColor") + "</body></html>");
    colorSpace.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        colorButton.setBackground(GanttGraphicArea.taskDefaultColor);
      }
    });

    colorPanel = new JPanel();
    colorPanel.setLayout(new BorderLayout());
    colorPanel.add(colorButton, "West");
    colorPanel.add(colorSpace, "Center");
    colorPanel.add( shapePanel, BorderLayout.EAST);
    lastRowPanel1.add(colorPanel);

    //---Set GridBagConstraints constant

    gbc.anchor = GridBagConstraints.WEST;
    gbc.insets.right = 15;
    gbc.insets.left = 10;
    gbc.insets.top = 10;
    addUsingGBL(generalPanel, firstRowPanel1, gbc, 0, 0, 1, 1);
    addUsingGBL(generalPanel, secondRowPanel1, gbc, 0, 1, 1, 1);
    addUsingGBL(generalPanel, thirdRowPanel1, gbc, 0, 2, 1, 1);
    gbc.gridx = 0;
    gbc.gridy = 3;
    gbc.gridwidth = 1;
    gbc.gridheight = GridBagConstraints.RELATIVE;
    gbc.anchor = GridBagConstraints.WEST;
    gbc.weighty = 1;
    generalPanel.add(lastRowPanel1, gbc);

  }

  /** Add the differents action listener on the differents widgets */
  public void addActionListener(ActionListener l) {

    nameField1.addActionListener(l);
    
    startDateButton1.addActionListener(l);

    finishDateButton1.addActionListener(l);

    okButton.addActionListener(l);

    cancelButton.addActionListener(l);

    durationField1.addActionListener(l);

  }
  
  /** Change the name of the task on all textfiled of task name */
  public void changeNameOfTask() {
  	if(nameField1!=null && nameField2!=null && nameField3!=null && nameFieldNotes!=null) {
		String nameOfTask = nameField1.getText().trim();
	  	nameField1.setText(nameOfTask);
		nameField2.setText(nameOfTask);
		nameField3.setText(nameOfTask);
		nameFieldNotes.setText(nameOfTask);
	}
  }

  /**Construct the predecessors tabbed pane*/

  private void constructPredecessorsPanel() {

    predecessorsPanel = new JPanel(new GridBagLayout());

    //first row

    nameLabel2 = new JLabel(language.getText("name") + ":");

    nameField2 = new JTextField(20);

    durationLabel2 = new JLabel(language.getText("length") + ":");

    durationField2 = new JTextField(8);

    firstRowPanel2 = new JPanel(flowL);

    nameField2.setEditable(false);

    durationField2.setEditable(false);

    setFirstRow(firstRowPanel2, gbc, nameLabel2, nameField2, durationLabel2,

                durationField2);

    //Second row

    PredecessorsTableModel predecessorsTableModel = new PredecessorsTableModel();

    predecessorsTable = new JTable(predecessorsTableModel);

    predecessorsTable.setPreferredScrollableViewportSize(new Dimension(500, 130));
		
    setUpPredecessorComboColumn(predecessorsTable.getColumnModel().getColumn(1), predecessorsTable); //set column editor

    setUpTypeComboColumn(predecessorsTable.getColumnModel().getColumn(2)); //set column editor

    predecessorsTable.setRowHeight(23); //set row height

    predecessorsTable.getColumnModel().getColumn(0).setPreferredWidth(10); //set column size

    predecessorsTable.getColumnModel().getColumn(1).setPreferredWidth(240);

    predecessorsTable.getColumnModel().getColumn(2).setPreferredWidth(60);

    predecessorsScrollPane = new JScrollPane(predecessorsTable);
	
	JPanel secondPredecessorsPanel=new JPanel();
	secondPredecessorsPanel.setBorder(new TitledBorder(new EtchedBorder(),
        language.getText("predecessors")));
	secondPredecessorsPanel.add(predecessorsScrollPane);
	
	JButton bremove=new TestGanttRolloverButton(new ImageIcon(getClass().getResource(
        "/icons/delete_16.gif")));
	bremove.setToolTipText("<html><body bgcolor=#FFFFBD>" + language.getText("removeRelationShip") +
                         "</body></html>");
	bremove.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        int [] selectedRow=predecessorsTable.getSelectedRows();
		for(int i=0;i<selectedRow.length;++i) {
			predecessorsTable.getModel().setValueAt("",selectedRow[i],0);
			predecessorsTable.getModel().setValueAt("",selectedRow[i],1);
			predecessorsTable.getModel().setValueAt("",selectedRow[i],2);
		}
      }
    });
	
	secondPredecessorsPanel.add(bremove);
	

    gbc.anchor = GridBagConstraints.WEST;

    gbc.insets.right = 15;

    gbc.insets.left = 10;

    gbc.insets.top = 10;

    gbc.weighty = 0;

    addUsingGBL(predecessorsPanel, firstRowPanel2, gbc, 0, 0, 1, 1);

    gbc.gridx = 0;

    gbc.gridy = 1;

    gbc.gridwidth = 8;

    gbc.gridheight = 1;

    gbc.weighty = 1;

    predecessorsPanel.add(secondPredecessorsPanel, gbc);

  }

  /**Construct the resources panel*/

  private void constructResourcesPanel(ArrayList users) {

    resourcesPanel = new JPanel(new GridBagLayout());

    //first row

    nameLabel3 = new JLabel(language.getText("name") + ":");

    nameField3 = new JTextField(20);

    durationLabel3 = new JLabel(language.getText("length") + ":");

    durationField3 = new JTextField(8);

    nameField3.setEditable(false);

    durationField3.setEditable(false);

    firstRowPanel3 = new JPanel(flowL);

    setFirstRow(firstRowPanel3, gbc, nameLabel3, nameField3, durationLabel3,

                durationField3);

    //Second row

    ResourcesTableModel resourcesTableModel = new ResourcesTableModel(
        selectedTask);

    resourcesTable = new JTable(resourcesTableModel);

    resourcesTable.setPreferredScrollableViewportSize(new Dimension(500, 130));

    setUpResourcesComboColumn(users, resourcesTable); //set column editor

    //set column size

    resourcesTable.setRowHeight(23);

    resourcesTable.getColumnModel().getColumn(0).setPreferredWidth(10);

    resourcesTable.getColumnModel().getColumn(1).setPreferredWidth(240);

    resourcesTable.getColumnModel().getColumn(2).setPreferredWidth(60);

    resourcesScrollPane = new JScrollPane(resourcesTable);
	
	JPanel secondResourcesScrollPane=new JPanel();
	secondResourcesScrollPane.setBorder(new TitledBorder(new EtchedBorder(),
        GanttProject.correctLabel(language.getText("human"))));
	secondResourcesScrollPane.add(resourcesScrollPane);
	
	
	JButton bremove=new TestGanttRolloverButton(new ImageIcon(getClass().getResource(
        "/icons/delete_16.gif")));
	bremove.setToolTipText("<html><body bgcolor=#FFFFBD>" + language.getText("removeResources") +
                         "</body></html>");
	bremove.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        int [] selectedRow=resourcesTable.getSelectedRows();
		for(int i=0;i<selectedRow.length;++i) {
			resourcesTable.getModel().setValueAt("",selectedRow[i],0);
			resourcesTable.getModel().setValueAt("",selectedRow[i],1);
			resourcesTable.getModel().setValueAt("",selectedRow[i],2);
		}
      }
    });
	secondResourcesScrollPane.add(bremove);
	
	gbc.anchor = GridBagConstraints.WEST;

    gbc.insets.right = 15;

    gbc.insets.left = 10;

    gbc.insets.top = 10;

    gbc.weighty = 0;

    addUsingGBL(resourcesPanel, firstRowPanel3, gbc, 0, 0, 1, 1);

    gbc.gridx = 0;

    gbc.gridy = 1;

    gbc.gridwidth = 8;

    gbc.gridheight = 1;

    gbc.weighty = 1;

    resourcesPanel.add(secondResourcesScrollPane, gbc);
  }

  /**construct the notes pannel*/

  private void constructNotesPanel() {

    notesPanel = new JPanel(new GridBagLayout());

    //first row

    nameLabelNotes = new JLabel(language.getText("name") + ":");

    nameFieldNotes = new JTextField(20);

    durationLabelNotes = new JLabel(language.getText("length") + ":");

    durationFieldNotes = new JTextField(8);

    nameFieldNotes.setEditable(false);

    durationFieldNotes.setEditable(false);

    firstRowPanelNotes = new JPanel();

    setFirstRow(firstRowPanelNotes, gbc, nameLabelNotes, nameFieldNotes,

                durationLabelNotes, durationFieldNotes);

    secondRowPanelNotes = new JPanel();

    secondRowPanelNotes.setBorder(new TitledBorder(new EtchedBorder(),
        language.getText("notesTask") + ":"));

    noteAreaNotes = new JTextArea(8, 40);
    noteAreaNotes.setLineWrap(true);
    noteAreaNotes.setWrapStyleWord(true);
    noteAreaNotes.setBackground(new Color(1.0f, 1.0f, 1.0f));

    scrollPaneNotes = new JScrollPane(noteAreaNotes);

    secondRowPanelNotes.add(scrollPaneNotes);

    JButton bdate = new TestGanttRolloverButton(new ImageIcon(getClass().getResource(
        "/icons/clock_16.gif")));
    bdate.setToolTipText("<html><body bgcolor=#FFFFBD>" + language.getText("putDate") +
                         "</body></html>");
    bdate.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        noteAreaNotes.append("\n"+ GanttCalendar.getDateAndTime() +"\n");
      }
    });
    secondRowPanelNotes.add(bdate);

    gbc.anchor = GridBagConstraints.WEST;

    gbc.insets.right = 15;

    gbc.insets.left = 10;

    gbc.insets.top = 10;

    gbc.weighty = 0;

    addUsingGBL(notesPanel, firstRowPanelNotes, gbc, 0, 0, 1, 1);

    gbc.weighty = 1;

    gbc.gridx = 0;

    gbc.gridy = 1;

    gbc.gridwidth = 1;

    gbc.gridheight = 1;

    notesPanel.add(secondRowPanelNotes, gbc);

  }

  /**Construct the south panel*/

  private void constructSouthPanel() {

    okButton = new JButton(language.getText("ok"));

    okButton.setName("ok");

    //getRootPane().setDefaultButton(okButton); //set ok the defuault button when press "enter"  --> check because getRootPane()==null !!!

    cancelButton = new JButton(language.getText("cancel"));

    cancelButton.setName("cancel");

    southPanel = new JPanel(new FlowLayout(FlowLayout.TRAILING, 50, 10));

    southPanel.add(okButton);

    southPanel.add(cancelButton);

  }

  /** Constructor */
  public GanttTaskPropertiesBean(JDialog parent, GanttTask selectedTask,
                                 GanttTree tree,
                                 Hashtable managerHash) {

    this.parent = parent;

    this.selectedTask = selectedTask;
	savePredecessors=selectedTask.getPredecessors();
    HumanResourceManager hr = (HumanResourceManager) managerHash.get(
        "HUMAN_RESOURCE");
    init(hr.getResources());
    this.managerHash = managerHash;

    setSelectedTask(selectedTask);

    setTree(tree);

    //set predecessor comboBox

    setUpPredecessorComboColumn(predecessorsTable.getColumnModel().getColumn(1), predecessorsTable); //set column editor

    setUpTypeComboColumn(predecessorsTable.getColumnModel().getColumn(2)); //set column editor

    //set resources comboBox

    /*        setUpResourcesComboColumn(((ResourceManager)managerHash.get("HUMAN_RESOURCE")).getResources(),
            resourcesTable.getColumnModel().getColumn(0)); //set column editor
     */

    /*
         tabbedPane = new JTabbedPane();
         constructGeneralPanel();
         tabbedPane.add("General", generalPanel);
         constructPredecessorsPanel();
         tabbedPane.add("Predecessors", predecessorsPanel);
         constructResourcesPanel();
         tabbedPane.add("Resources", resourcesPanel);
         constructNotesPanel();
         tabbedPane.add("Notes", notesPanel);
         add(tabbedPane);*/

  }

  /** Init the widgets */
  public void init(ArrayList users) {

    tabbedPane = new JTabbedPane();
    tabbedPane.addChangeListener(new ChangeListener() {
    	public void stateChanged(ChangeEvent e) {
		changeNameOfTask();
	}
    });
    constructGeneralPanel();

    tabbedPane.add(language.getText("general"), generalPanel);

    constructPredecessorsPanel();

    tabbedPane.add(language.getText("predecessors"), predecessorsPanel);

    constructResourcesPanel(users);

    tabbedPane.add(GanttProject.correctLabel(language.getText("human")), resourcesPanel);

    constructNotesPanel();

    tabbedPane.add(language.getText("notesTask"), notesPanel);

    setLayout(new BorderLayout());

    add(tabbedPane, BorderLayout.CENTER);

    constructSouthPanel();

    add(southPanel, BorderLayout.SOUTH);

  }

  
  //Input methods

  /**as the name indicated, it will not replace the original GanttTask in the Tree. */

  public GanttTask getReturnTask() {
    GanttTask returnTask = selectedTask.Clone();
    returnTask.setTaskID(selectedTask.getTaskID());
    returnTask.setName(getTaskName()); //getName()
    returnTask.setBilan(isBilan());
    returnTask.setChecked(false);
    returnTask.setStart(getStart());
    returnTask.setEnd(getEnd());
    returnTask.setLength(getLength());
    returnTask.setNotes(getNotes());
    returnTask.setPercent(getPercentComplete());
    returnTask.setPriority(getPriority());
    returnTask.setPredecessors(getPredecessors());


	//Process to remove the selected task to the list of sucessors of the predecessors ;-)
	for(Iterator is=savePredecessors.iterator();is.hasNext();) {
		GanttTaskRelationship relationship = (GanttTaskRelationship)is.next();

		boolean ok=false;
		for(Iterator is2=getPredecessors().iterator();is2.hasNext() && !ok;) {
			GanttTaskRelationship relationship2 = (GanttTaskRelationship)is2.next();
			if(relationship2.getPredecessorTaskID() == relationship.getPredecessorTaskID() && 
			   relationship2.getRelationshipType()  == relationship.getRelationshipType()) {
				ok=true;
			}
		}
		if(!ok){
			GanttTask p = relationship.getPredecessorTask();
			GanttTaskRelationship predRela = new GanttTaskRelationship(
										 -1, selectedTask.getTaskID(), relationship.getRelationshipType());
			p.removeSuccessor(predRela);
		}
	}
	
	
	
    returnTask.setSuccessors(selectedTask.getSuccessors()); //the Clone might not be good at this moment
    returnTask.setResources(getResources());

// Save resource edits here

    returnTask.setColor(colorButton.getBackground());
    returnTask.setShape(new ShapePaint((ShapePaint)shapeComboBox.getSelectedPaint(), Color.white, colorButton.getBackground()));

    return returnTask;

  }

  /**as the name indicated*/

  public void setSelectedTask(GanttTask selectedTask) {

    this.selectedTask = selectedTask;

    nameField1.setText(selectedTask.toString());

    nameField2.setText(selectedTask.toString());

    nameField3.setText(selectedTask.toString());

    nameFieldNotes.setText(selectedTask.toString());

    setName(selectedTask.toString());

    durationField1.setText(selectedTask.getLength() + "");

    durationField2.setText(selectedTask.getLength() + "");

    durationField3.setText(selectedTask.getLength() + "");

    durationFieldNotes.setText(selectedTask.getLength() + "");

    percentCompleteSlider.setValue(new Integer(selectedTask.getPercent()));
    percentCompleteLabel1.setText(language.getText("advancement"));

    priorityComboBox.setSelectedIndex(selectedTask.getPriority());

    startDateField1.setText(selectedTask.getStart().toString());

    finishDateField1.setText(selectedTask.getEnd().toString());

    setStart(selectedTask.getStart().Clone(), false);

    setEnd(selectedTask.getEnd().Clone(), false);

    bilan = selectedTask.getBilan();

    mileStoneCheckBox1.setSelected(bilan);
    
    
    if(selectedTask.shapeDefined()) {
	for(int i=0;i<ShapeConstants.PATTERN_LIST.length;i++) {
		if(selectedTask.getShape().equals(ShapeConstants.PATTERN_LIST[i])) {
			shapeComboBox.setSelectedIndex(i);
			break;
		}
	}
    }

    predecessors = new Vector();

    TableModel predecessorsTableModel = predecessorsTable.getModel();

    //If Task ID is used, the following code should be changed base on TaskID

    predecessors = selectedTask.getPredecessors();

    for (int i = 0; i < predecessors.size(); i++) {

      GanttTaskRelationship predecessor = (GanttTaskRelationship) predecessors.

          get(i);

      predecessorsTableModel.setValueAt(""+predecessor.getPredecessorTask().getTaskID(),i,0);
      predecessorsTableModel.setValueAt(""+predecessor.getPredecessorTask().getTaskID()+" - "+predecessor.getPredecessorTask(), i, 1);

      switch (predecessor.getRelationshipType()) {

        case GanttTaskRelationship.FF:

          predecessorsTableModel.setValueAt(language.getText("finishfinish") /*"Finish-Finish"*/,
                                            i, 2);

          break;

        case GanttTaskRelationship.SF:

          predecessorsTableModel.setValueAt(language.getText("startfinish") /*"Start-Finish"*/, i,
                                            2);

          break;

        case GanttTaskRelationship.SS:

          predecessorsTableModel.setValueAt(language.getText("startstart") /*"Start-Start"*/, i,
                                            2);

          break;

        case GanttTaskRelationship.FS:

          predecessorsTableModel.setValueAt(language.getText("finishstart") /*"Finish-Start"*/, i,
                                            2);

          break;

      }

      String taskName = predecessorsTableModel.getValueAt(i, 1).toString();

    }

    noteAreaNotes.setText(selectedTask.getNotes());

  }

  /**as the name indicated*/

  public void setTree(GanttTree tree) {

    this.tree = tree;

  }

  //Output methods

  /**as the name indicated*/

  public boolean isBilan() {

    bilan = mileStoneCheckBox1.isSelected();

    return bilan;

  }

  /**as the name indicated*/

  public GanttCalendar getEnd() {

    return end;

  }

  /**as the name indicated*/

  public int getLength() {

    length = Integer.parseInt(durationField1.getText().trim());

    return length;

  }

  /** Set the duration of the task */
  public void changeLength(int _length) {

    durationField1.setText(_length + "");
    durationField2.setText(_length + "");
    durationField3.setText(_length + "");
    durationFieldNotes.setText(_length + "");

    length = _length;

    //change the end date
    GanttCalendar _end = start.newAdd(length);
    this.end = _end;
    finishDateField1.setText(_end.toString());

  }

  /**as the name indicated*/

  public String getNotes() {

    notes = noteAreaNotes.getText();

    return notes;

  }

  /** Return the name of the task*/

  public String getTaskName() {
    String text = nameField1.getText();
    return text == null ? "" : text.trim();
  }

  /**as the name indicated*/

  public int getPercentComplete() {

    percentComplete = ((Integer)percentCompleteSlider.getValue()).hashCode();

    return percentComplete;

  }

  /** Return the priority level of the task */

  public int getPriority() {
    priority = priorityComboBox.getSelectedIndex();
    return priority;
  }

  /**as the name indicated. there is no getSuccessors as you cannot change the successor in GUI*/

  public Vector getPredecessors() {
    Vector predecessors = new Vector();
    GanttTaskRelationship relationship = null;
    TableModel model = predecessorsTable.getModel();
    for (int i = 0; i < model.getRowCount(); i++) {
      String taskName = model.getValueAt(i, 1).toString(); 
      
      
      if (taskName != null) {
        int indexOfTiret = taskName.indexOf(" - ");
	if(indexOfTiret==-1) continue;
        String stringTtaskID = taskName.substring(0,indexOfTiret);
	int taskID = new Integer(stringTtaskID).intValue();
        GanttTask task= TaskManager.Access.getInstance().getTask(taskID);
	//System.out.println(taskID+" "+task);
        //GanttTask task = tree.getTask(taskName);
        if (task != null) { 
          relationship = new GanttTaskRelationship();
          String type = model.getValueAt(i, 2).toString().trim();
          if (type.equals(language.getText("finishfinish") /*"Finish-Finish"*/)) {
            relationship.setPredecessorTask(task);
            relationship.setRelationshipType(GanttTaskRelationship.FF);
          }

          else if (type.equals(language.getText("finishstart") /*"Finish-Start"*/)) {
            relationship.setPredecessorTask(task);
            relationship.setRelationshipType(GanttTaskRelationship.FS);
          }

          else if (type.equals(language.getText("startstart") /*"Start-Start"*/)) {

            relationship.setPredecessorTask(task);

            relationship.setRelationshipType(GanttTaskRelationship.SS);
          }
          else if (type.equals(language.getText("startfinish") /*"Start-Finish"*/)) {

            relationship.setPredecessorTask(task);

            relationship.setRelationshipType(GanttTaskRelationship.SF);

          }

          else {

            continue;

          }

          predecessors.add(relationship);

          //////the code exist for the use of depend instead of predecessors

          //task.setDepend(selectedTask.toString());

        }

      }

    }

    return predecessors;

  }

  /** Return the resource arraylist for the task*/

  public ArrayList getResources() {
    ArrayList users = new ArrayList();
    TableModel model = resourcesTable.getModel();

    for (int i = 0; i < model.getRowCount(); i++) {
      Hashtable ht = new Hashtable();

      if (model.getValueAt(i, 1)instanceof HumanResource &&
          model.getValueAt(i, 2) != null) {
        try {
          //System.out.println ("Adding: "+model.getValueAt(i, 1));
          HumanResource hr = (HumanResource) model.getValueAt(i, 1);
          ht.put("NAME", hr.getName());

          ht.put("LOAD", Integer.valueOf( (String) model.getValueAt(i, 2)));
          ht.put("USER_OBJECT", hr);
          users.add(ht);
        }
        catch (Exception e) {
          System.out.println("ERROR on converting data. Resource skipped.");
        }

      }
    }
    return users;
  }

  /** Return the start date of the task */
  public GanttCalendar getStart() {

    return start;

  }

  /** Change the start date of the task */
  public void setStart(GanttCalendar start, boolean test) {

    //System.out.println("Start : "+start);
    startDateField1.setText(start.toString());
    this.start = start;
		
		length=start.diff(end);
		durationField1.setText(""+length);
		durationField2.setText(""+length);
		durationField3.setText(""+length);
		durationFieldNotes.setText(""+length);
		
    if (test) {
      GanttCalendar _end = start.newAdd(length);
      this.end = _end;
      finishDateField1.setText(_end.toString());
    }
  }

  /** Change the end date of the task */
  public void setEnd(GanttCalendar end, boolean test) {

    //System.out.println("end : "+end);
    finishDateField1.setText(end.toString());
    this.end = end;
		
		length=start.diff(end);
		durationField1.setText(""+length);
		durationField2.setText(""+length);
		durationField3.setText(""+length);
		durationFieldNotes.setText(""+length);
		
    if (test) {
      GanttCalendar _start = end.newAdd( -length);
      this.start = _start;
      startDateField1.setText(_start.toString());
    }
  }

}

/**
 * Class use to make model for table for predessossors
 */
class PredecessorsTableModel
    extends AbstractTableModel {

  final String[] columnNames = {
      GanttLanguage.getInstance().getText("id"),

      GanttLanguage.getInstance().getText("taskname"),

      GanttLanguage.getInstance().getText("type")};

  final Object[][] data = new Object[100][];

  {

    for (int i = 0; i < 100; i++) {

      data[i] = new Object[] {
          "", "", ""};

    }

  }

  /** Return the number of colums */
  public int getColumnCount() {

    return columnNames.length;

  }

  /** Return the numbers of rows */
  public int getRowCount() {

    return data.length;

  }

  /** Return the name of the colums col */
  public String getColumnName(int col) {

    return columnNames[col];

  }

  /** Return the object at the specify row & colums */
  public Object getValueAt(int row, int col) {

    if (data[row] == null || data[row][col] == null) {

      return "";

    }

    else {

      return data[row][col];

    }

  }

  /*
   * JTable uses this method to determine the default renderer/
   * editor for each cell.  If we didn't implement this method,
   * then the last column would contain text ("true"/"false"),
   * rather than a check box.
   */

  public Class getColumnClass(int c) {

    return getValueAt(0, c).getClass();

  }

  /*
   * Don't need to implement this method unless your table's
   * editable.
   */

  public boolean isCellEditable(int row, int col) {

    //Note that the data/cell address is constant,

    //no matter where the cell appears onscreen.

    if (col < 1) {

      return false;

    }

    else {

      return true;

    }

  }

  /*
   * Don't need to implement this method unless your table's
   * data can change.
   */

  public void setValueAt(Object value, int row, int col) {

    //data[row]=new Object[20];

    data[row][col] = value.toString(); //cannot use Object value

    fireTableCellUpdated(row, col);

  }

}

/**
 * Model of table for resources
 */
class ResourcesTableModel
    extends AbstractTableModel {

  final String[] columnNames = {
      GanttLanguage.getInstance().getText("id"),
      GanttLanguage.getInstance().getText("resourcename"),
      GanttLanguage.getInstance().getText("unit")};
  final Object[][] data = new Object[100][];

  /**Constructor */
  public ResourcesTableModel(GanttTask selectedTask) {

    //System.out.println("Resourcenzuordnung durchfhren.");

    if (selectedTask == null) {
      System.out.println("selected Task is null");
      return;
    }
    ArrayList users = selectedTask.getUsersList();

    int i = 0;

    if (users != null && users.size() > 0) {
      for (i = 0; i < users.size(); i++) {
        //            System.out.println(users.get(i).getClass().getName());
        Hashtable ht = (Hashtable) users.get(i);
        HumanResource hr = (HumanResource) ht.get("USER_OBJECT");

        data[i] = new Object[] {
            String.valueOf(hr.getId()),
            ht.get("USER_OBJECT"),
            ( (Integer) ht.get("LOAD")).toString()};

      }
    }
    for (int j = i; j < data.length; j++) {
      data[j] = new Object[3]; // {"", "", ""};
    }
  }

  /** Return the number of colums */
  public int getColumnCount() {

    return columnNames.length;

  }

  /** Return the number of rows */
  public int getRowCount() {

    return data.length;

  }

  /** Return the name of the column at col index */
  public String getColumnName(int col) {

    return columnNames[col];

  }

  /** Return the object a specify cell */
  public Object getValueAt(int row, int col) {
    return data[row][col];

  }

  /*
   * JTable uses this method to determine the default renderer/
   * editor for each cell.  If we didn't implement this method,
   * then the last column would contain text ("true"/"false"),
   * rather than a check box.
   */

  public Class getColumnClass(int c) {
    if (c == 0 || c == 2) {
      return new String().getClass();
    }
    else {
      return new HumanResource().getClass();
    }
//        return getValueAt(0, c).getClass();
  }

  public boolean isCellEditable(int row, int col) {

    return true;

  }

  /*
   * Don't need to implement this method unless your table's
   * data can change.
   */

  public void setValueAt(Object value, int row, int col) {

    data[row][col] = value;

    fireTableCellUpdated(row, col);

  }

}
