

package net.sourceforge.ganttproject.roles;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Enumeration;
import java.util.Hashtable;

import net.sourceforge.ganttproject.language.GanttLanguage;

/**
 * @author athomas
 *
 */
public class RoleManagerImpl implements RoleManager {

	
	String [] defaultRoles;
	
	public RoleManagerImpl () {
		GanttLanguage language=GanttLanguage.getInstance();
		defaultRoles = new String [] {
			language.getText("resUndefined"),
			language.getText("resProjectManager"),
			language.getText("resDeveloper"),
			language.getText("resDocWriter"),
			language.getText("resTester"),
			language.getText("resGraphicDesigner"),
			language.getText("resDocTranslator"),
			language.getText("resPackager"),
			language.getText("resAnalysis"),
			language.getText("resWebDesigner"),
			language.getText("resNoSpecificRole")
		};
		language=null;
	}
	
	public void clear(){
		myId2Role.clear();
	}
    
	public String [] getRoles() {
		String []res = new String [DEFAULT_ROLES_NUMBER+myId2Role.size()];
		int i;
		for(i=0;i<DEFAULT_ROLES_NUMBER;i++) res[i] = defaultRoles[i];
		
		int [] key = new int [myId2Role.size()];
		int j=0;
		for(Enumeration e = myId2Role.keys(); e.hasMoreElements() ; j++)
			key[j]=((Integer)e.nextElement()).hashCode();
		Arrays.sort(key);
		
		for(j=0;j<key.length;j++,i++)
			res[i]=(String)(myId2Role.get(new Integer(key[j])));
				
		return res;
	}
	
	public String [] getRolesShort() {
		String []res = new String [myId2Role.size()];
		int i=0;
		
		ArrayList tmpArray=new ArrayList();
		for(Enumeration e = myId2Role.elements(); e.hasMoreElements() ; )
			tmpArray.add(e.nextElement());

		for(int j=tmpArray.size()-1;j>=0;j--,i++)
			res[i]=(String)tmpArray.get(j);
		
		return res;
	}
	
	
	public void setRoles (Hashtable roles) {
		myId2Role=roles;
	}
	
	public String getRole (int ID) {
		if(ID<DEFAULT_ROLES_NUMBER) return defaultRoles[ID];
		/*else*/  return (String)myId2Role.get(new Integer(ID));
	}
	
	/** Return the number of roles for the project, exept the default roles*/
	public int nbOfRoles(){
		return myId2Role.size();
	}
	
	/** Add a role on the list */
	public void add (int ID, String role){
		myId2Role.put(new Integer(ID), role);
	}
	
	/** Load roles from the file*/
	/*public void load(InputStream source){
		XMLReader reader;
        
        try {
            reader = XMLReaderFactory.createXMLReader (
                "org.apache.crimson.parser.XMLReaderImpl");
        }
        catch (Exception e) {
            System.out.println ("Opening parser failed:"+e.toString());
            return;
        }
        
        ContentHandler rolesLoader = new RolesLoader(this);
        reader.setContentHandler(rolesLoader);
        
        clear();
        
        try {
            reader.parse(new InputSource(source));
        }
        catch (Exception e) {
            System.out.println ("Opening parser failed:"+e.toString());
            return ;
        }
	}*/
	
	
	//Hashmap contains ID of the roles and the string for the role
	//But not contains the other roles that are allready select and translate for the differents languages.
    private Hashtable myId2Role = new Hashtable();

}
