/*
 * Created on 05.07.2003
 *
 */
package net.sourceforge.ganttproject.task;

import java.util.HashMap;
import java.util.Map;

import net.sourceforge.ganttproject.GanttCalendar;
import net.sourceforge.ganttproject.GanttTask;

/**
 * @author bard
 *
 */
public class TaskManagerImpl implements TaskManager {

    /* (non-Javadoc)
     * @see net.sourceforge.ganttproject.task.TaskManager#getTask(int)
     */
    public GanttTask getTask(int taskId) {
        return (GanttTask)myId2task.get(new Integer(taskId));
    }

    /* (non-Javadoc)
     * @see net.sourceforge.ganttproject.task.TaskManager#clear()
     */
    public void clear() {
        myId2task.clear();
		setMaxID(0);
    }

    public GanttTask createTask() {
        GanttTask result = createTask(getMaxID());
        increaseMaxID();
        return result;
    }
    
    /* (non-Javadoc)
     * @see net.sourceforge.ganttproject.task.TaskManager#createTask(int)
     */
    public GanttTask createTask(int taskId) {
        GanttTask result = new GanttTask("", new GanttCalendar(), -1);
        result.setTaskID(taskId);
		return result;
    }

    /* (non-Javadoc)
     * @see net.sourceforge.ganttproject.task.TaskManager#registerTask(net.sourceforge.ganttproject.GanttTask)
     */
    public void registerTask(GanttTask task) {
        int taskID = task.getTaskID();
        if (myId2task.get(new Integer(taskID)) == null) { //if the taskID is not in the map
          myId2task.put(new Integer(taskID), task);
          if (getMaxID() < taskID) {
            setMaxID(taskID+1);
          }
        }
        else { //taskID has been in the map. the newTask will not be added
            throw new RuntimeException("There is a task that already has the ID " + taskID);
        }
    }

    /* (non-Javadoc)
     * @see net.sourceforge.ganttproject.task.TaskManager#setTask(net.sourceforge.ganttproject.GanttTask)
     */
    public void setTask(GanttTask task) {
    	int taskID = task.getTaskID();
		myId2task.put(new Integer(taskID), task);		
		if (taskID > getMaxID()) {
		  setMaxID(taskID);
		}
    }
    
    public int getMaxID() {
        return myMaxID;
    }
    
    private void setMaxID(int id) {
        myMaxID = id;
    }
    
    private void increaseMaxID() {
    	myMaxID++;
    }
    private int myMaxID;
    private Map myId2task = new HashMap();

}
